GuidesAPI Reference
Guides

EV Charge Points

📘

Note

For information about the pricing of the EV Charge Points feature, see the HERE Base Plan Pricing. If you have questions about pricing, contact us.

This section describes the EV Charge Point attributes returned by HERE Geocoding and Search when the query parameters show=ev or show=eMobilityServiceProviders are set.

EV Charge Point attributes belong to place results of following category IDs:

  • 700-7600-0322 (EV charging station for passenger cars)
  • 700-7600-0323 (EV charging station for trucks)
  • 700-7600-0324 (EV charging station for two-wheelers and light vehicles)

An EV charging station is a cluster of nearby EV supply equipment (EVSE) belonging to the same charge point operator (CPO) and sharing the same features. The CPO name is in most of the cases used to represent the place result title.

EV station connectors information

To get EV stations connector attributes in HERE Geocoding and Search, use the dedicated query parameter show=ev.

Customers authorized to use the show=ev query parameter will always see the CPO name as supplierName field value.

The endpoints supporting the show=ev option are the /browse, /discover and /lookup endpoints.

Example: EV station results

For instance, the following /browse endpoint request returns the three EV stations nearest to the current car position (at= 52.3039368,4.7509823). The first station is operated by Electrify America, the second by Tesla, and so on.

GET https://browse.search.hereapi.com/v1/
    browse
    ?at=52.3039368,4.7509823
    &categories=700-7600-0322
    &limit=3
    &show=ev
-H 'Authorization: Bearer{YOUR_TOKEN}'
{
  "items": [
    {
      "title": "EVBox",
      "extended": {
        "evStation": {
          "connectors": [
            { "supplierName": "EVBox",
      ...
    },
    {
      "title": "TotalEnergies",
      "extended": {
        "evStation": {
          "connectors": [
            { "supplierName": "TotalEnergies",
      ...
    },
    {
      "title": "Maxem Energy",
      "extended": {
        "evStation": {
          "connectors": [
            { "supplierName": "Maxem Energy",
      ...
    }
  ]
}

Each EV charging station result item has a set of extended attributes. Those are to be found in two different forms:

  • group form: The extended.evStation.connectors array describes the EV charging station as a group of connectors characterized by the same type and maximum power level.
  • detailed form: the extended.evAvailability.stations array contains further details of the station, on the EV supply equipment (EVSE), and the connectors. The charger availability details are at the level of the EVSE.

The grouping of the connectors facilitates compact and readable rendering in the lists of results, enabling the end-users to quickly pick the search result item relevant to them.

The detailed representation of the EV charging stations is meant to facilitate the development of applications interacting with the CPO platform through the use of EVSE identifiers.

For the description of each attribute, see the API Reference documentation.

Example: EV station attributes

In the /browse endpoint example, the first response item is an EV charging station in Kearny, NJ (USA) at 150 Harrison Avenue. It has the following detailed representation:

  • Four EVSE: Four electric vehicles can simultaneously be charged at this station.
  • The first EVSE feeds either one connector of type id 33 (IEC 62196-3 type 1 combo, aka "CCS") with 350kW, or one connector of type id 29 (JEVS G 105, aka "CHAdeMO") with 50kW.
  • The second and third EVSE feed one connector of type id 33 with 350kW each.
  • The fourth EVSE feeds one connector of type 30 (IEC 62196-2 type 1, aka "Level 2") with 7.2kW.
Station, EVSE, and connectors

The information on the five connectors listed above is aggregated into three groups of sockets:

  • First group: One connector of type id 29 fed with max 50 kW
  • Second group: Three connectors of type id 33 fed with max 350kW
  • Third group: One connector of type id 30 fed with max 7.2 kW
connector groups

On 2023-09-28 at 11:47 UTC, the attributes were, as follows:

{
  "title": "Electrify America",
  "id": "here:pds:place:evcp0-MmU4ZjA5OGMtYThmOC0xMWViLWJlMmEtNDIwMTBhODQwMDAz",
  "resultType": "place",
  "address": {
    "label": "Electrify America, 150 Harrison Ave, Kearny, NJ 07032-5950, United States",
    ...
  },
  "position": { "lat": 40.74863, "lng": -74.13629 },
  "categories": [{ "id": "700-7600-0322", "name": "EV Charging Station", "primary": true }],
  ...
  "extended": {
    "evStation": {
      "connectors": [
        {
          "supplierName": "Electrify America",
          "connectorType": { "name": "IEC 62196-3 type 1 combo (SAE J1772)", "id": "33" },
          "fixedCable": true,
          "maxPowerLevel": 350,
          "chargingPoint": {
            "numberOfConnectors": 3,
            "voltsRange": "1000-1000V DC",
            "ampsRange": "350A",
            "numberOfAvailable": 1,
            "numberOfInUse": 2,
            "lastUpdateTimestamp": "2024-08-26T14:57:43.000Z"
          }
        },
        {
          "supplierName": "Electrify America",
          "connectorType": { "name": "IEC 62196-2 type 1 (SAE J1772)", "id": "30" },
          "fixedCable": true,
          "maxPowerLevel": 7.2,
          "chargingPoint": {
            "numberOfConnectors": 1,
            "voltsRange": "240-240V AC",
            "phases": 1,
            "ampsRange": "30A",
            "numberOfAvailable": 1,
            "lastUpdateTimestamp": "2024-08-25T23:08:53.000Z"
          }
        }
      ],
      "totalNumberOfConnectors": 4,
      "access": "public"
    },
    "evAvailability": {
      "stations": [
        {
          "id": "MmU4ZjA5OGMtYThmOC0xMWViLWJlMmEtNDIwMTBhODQwMDAz",
          "cpoId": "200104",
          "evses": [
            {
              "id": "ZWNvbW92ZW1lbnQ6MmU4ZjA5OGMtYThmOC0xMWViLWJlMmEtNDIwMTBhODQwMDAzOjIwMDEwNC0wMw",
              "cpoId": "200104-03",
              "cpoEvseEMI3Id": "200104-03",
              "state": "OCCUPIED",
              "last_updated": "2024-08-26T14:36:54.000Z",
              "connectors": [
                {
                  "id": "ZWNvbW92ZW1lbnQ6MmU4ZjA5OGMtYThmOC0xMWViLWJlMmEtNDIwMTBhODQwMDAzOjIwMDEwNC0wMzox",
                  "cpoId": "1",
                  "typeId": "33",
                  "maxPowerLevel": 350
                }
              ]
            },
            {
              "id": "ZWNvbW92ZW1lbnQ6MmU4ZjA5OGMtYThmOC0xMWViLWJlMmEtNDIwMTBhODQwMDAzOjIwMDEwNC0wMQ",
              "cpoId": "200104-01",
              "cpoEvseEMI3Id": "200104-01",
              "state": "OCCUPIED",
              "last_updated": "2024-08-26T14:57:16.000Z",
              "connectors": [
                {
                  "id": "ZWNvbW92ZW1lbnQ6MmU4ZjA5OGMtYThmOC0xMWViLWJlMmEtNDIwMTBhODQwMDAzOjIwMDEwNC0wMTox",
                  "cpoId": "1",
                  "typeId": "33",
                  "maxPowerLevel": 350
                }
              ]
            },
            {
              "id": "ZWNvbW92ZW1lbnQ6MmU4ZjA5OGMtYThmOC0xMWViLWJlMmEtNDIwMTBhODQwMDAzOjIwMDEwNC0wMg",
              "cpoId": "200104-02",
              "cpoEvseEMI3Id": "200104-02",
              "state": "AVAILABLE",
              "last_updated": "2024-08-26T14:57:43.000Z",
              "connectors": [
                {
                  "id": "ZWNvbW92ZW1lbnQ6MmU4ZjA5OGMtYThmOC0xMWViLWJlMmEtNDIwMTBhODQwMDAzOjIwMDEwNC0wMjox",
                  "cpoId": "1",
                  "typeId": "33",
                  "maxPowerLevel": 350
                }
              ]
            },
            {
              "id": "ZWNvbW92ZW1lbnQ6MmU4ZjA5OGMtYThmOC0xMWViLWJlMmEtNDIwMTBhODQwMDAzOjIwMDEwNC01MA",
              "cpoId": "200104-50",
              "cpoEvseEMI3Id": "200104-50",
              "state": "AVAILABLE",
              "last_updated": "2024-08-25T23:08:53.000Z",
              "connectors": [
                {
                  "id": "ZWNvbW92ZW1lbnQ6MmU4ZjA5OGMtYThmOC0xMWViLWJlMmEtNDIwMTBhODQwMDAzOjIwMDEwNC01MDox",
                  "cpoId": "1",
                  "typeId": "30",
                  "maxPowerLevel": 7.2
                }
              ]
            }
          ]
        }
      ]
    }
  }
}

Important response fields

Most important response elements in the basic response are the name of the charge point operator, the connector type. and the maximum power level.

In the example above, here are the response elements in the first connectors group:

  • Name of EV charge point operator: "Electrify America"

    Field extended.evStation.connectors[0].supplierName

  • Maximum power level in kilowatt: 50

    Field extended.evStation.connectors[0].maxPowerLevel

  • Number of available connectors: 1

    Field extended.evStation.connectors[0].chargingPoint.numberOfAvailable

  • Name (and ID) of connector types: "JEVS G 105 (CHAdeMO)" ("29")

    Field extended.evStation.connectors[0].connectorType

    The numerical value of a connector type ID always mean the same, but its name can slightly vary over time. Developers needing to post-filter response details using connector information, should consider the ID instead of the name.

    IDDescriptionNotes
    5Domestic plug/socket type B (NEMA 5-15)
    6Domestic plug/socket type B (NEMA 5-20)
    7Domestic plug/socket type D (BS 546 (3 pin))
    8Domestic plug/socket type E (CEE 7/5)
    9Domestic plug/socket type F (CEE 7/4 (Schuko))
    10Domestic plug/socket type E+F (CEE 7/7)
    11Domestic plug/socket type G (BS 1363, IS 401 & 411, MS 58)
    12Domestic plug/socket type H (SI 32)
    13Domestic plug/socket type I (AS/NZS 3112)
    14Domestic plug/socket type I (CPCS-CCC)
    15Domestic plug/socket type I (IRAM 2073)
    20Domestic plug/socket type K (Section 107-2-D1)
    21Domestic plug/socket type O (Thailand TIS 166 - 2549)
    22Domestic plug/socket type L (CEI 23-16/VII)
    23Domestic plug/socket type M (South African 15 A/250 V)
    24Domestic plug/socket type IEC 60906-1 (3 pin)
    25AVCON Connector
    29JEVS G 105 (CHAdeMO)
    30IEC 62196-2 type 1commonly known as "SAE J1772"
    31IEC 62196-2 type 2commonly known as "Type2"
    32IEC 62196-2 type 3c (SCAME)
    33IEC 62196-3 type 1 combocommonly known as "CCS1"
    34IEC 62196-3 type 2 combo (Mennekes)commonly known as "CCS2"
    35IEC 60309 : industrial P + N + E (AC)Industrial Connector single phase 16 Amperes (CEE, usually blue)
    36IEC 60309 : industrial 3P + E + N (AC)Industrial Connector three phase 16 Amperes (CEE, usually red)
    37IEC 60309 : industrial 2P + E (AC)
    42Domestic plug/socket type J (SEV 1011) (T13, T23)
    43Tesla Connectorcommonly known as "NACS" (North American Charging Standard)
    46IEC 60309 : industrial 2P + E (DC)
    48Domestic plug/socket type A (NEMA 1-15, 2 pins)
    49Domestic plug/socket type C (CEE 7/17, 2 pins)
    50IEC 62196-2 type 3a (SCAME)
    52GB/T (Chinese) AC connector
    53GB/T (Chinese) DC connector
📘

Note

The applications shall cover the fact that none of the EV Charging station attributes are mandatory.

Connector availability

The EV station connectors availability is located in both evStations and evAvailability response elements.

The group availability in evStation is useful to display how many connectors of a certain type are available.

The detailed availability in evAvailability can be used to locate a free charger.

Group availability

The response element evStation is enriched with the following information on the connectors group availability:

  • lastUpdateTimestamp: the last time the connector group statistics has been updated
  • numberOfAvailable: the number of connectors that are available at the time of the last update
  • numberOfInUse: the number of connectors in use available at the time of the last update

In the above example, the group connector availability is the presented as:

  • First group: 1/1 connector CHAdeMO has been available since 2023-09-25 09:59:17
  • Second group: 3/3 connectors IEC 62196-3 type 1 combo have been available since latest 2023-09-25 10:24:18
  • Third group: 1/1 connector IEC 62196-3 type 1 combo has been available since 2023-09-20 14:59:22

Detailed availability

The EV charging station details are based on the eMI3/OCPI industry standards.

The connectors are associated with their related EV supply equipment (EVSE), and the EVSE is usually associated with its own parking slot. The number of EVSE is the total number of electric vehicles that can be charged simultaneously at that station.

The response element evAvailability contains the following information:

  • Charge Point Operator IDs for stations and EVSE:

    • extended.evAvailability.stations[].cpoId: The CPO location ID
    • extended.evAvailability.stations[].evses[].cpoEvseEMI3Id: The EVSE identifier. This ID is globally unique.
    • extended.evAvailability.stations[].evses[].cpoId: The EVSE identifier in the CPO system.

    You can use both evses[].cpoId and evses[].cpoEvseEMI3Id parameters for external referencing.

  • The operational state of EVSEs and their related connectors:

    NameNotes
    AVAILABLEThe EVSE or Connector is able to start a new charging session.
    UNAVAILABLEThe EVSE or Connector is not available because of a physical barrier, for example a car.
    OCCUPIEDThe EVSE or Connector is in use
    OUT_OF_SERVICEThe EVSE or Connector is currently out of order.
    RESERVEDThe EVSE or Connector has been reserved for a particular EV driver and is unavailable for other drivers.
    OFFLINE or OTHERNo status information available. (Also used when offline)
  • Their state last_updated time.

eMobility Service Providers

An eMobility Service Provider (eMSP) is a company or organization that provides electric vehicle (EV) charging roaming services.

When using EV roaming, electric vehicle drivers can access charging services at various participating charging networks. eMSPs provide billing and payment services for EV charging, as well as technical support and customer service.

With show=eMobilityServiceProviders, customers can get the EV roaming details added to extended.evStation.

The details consist of name and partner_id of the eMSP. The partner_id can also be used to filter the search results for preferred eMSP providers.

For instance the Electrify America charging station from the example above, at 150 Harrison Ave, has the e-mobility service provider partner ID 2d6b7068-cca5-11ed-b653-42010aa40002:

 GET https://lookup.search.hereapi.com/v1/
    lookup
    ?id=here:pds:place:evcp0-MmU4ZjA5OGMtYThmOC0xMWViLWJlMmEtNDIwMTBhODQwMDAz
    &show=eMobilityServiceProviders
-H 'Authorization: Bearer{YOUR_TOKEN}'
{
    "title": "Electrify America",
    "id": "here:pds:place:evcp0-MmU4ZjA5OGMtYThmOC0xMWViLWJlMmEtNDIwMTBhODQwMDAz",
  ...
    "extended": {
      "evStation": {
        "access": "public",
        "eMobilityServiceProviders": [{ "name": "Electrify America", "partnerId": "2d6b7068-cca5-11ed-b653-42010aa40002" }]
      }
    }
  }
📘

Note

For more information on the EV Charge Points, see the EV Charge Points documentation.

Additional detailed and exclusive EV Charge Points attributes can be fetched from the EV Charge Points API v3. For more information, see the EV Charge Points API v3 documentation. It is important to note that HERE Geocoding and Search and EV Charge Points API share the backend database and place IDs, therefore they integrate seamlessly.